#include<bits/stdc++.h>
#define MAXN 100007
using namespace std;

struct node{
    long long whole;
    long long small;
    long long leftb;
    long long rightb;
    long long ans;
};

int n,m,pos,c;
int a[MAXN];
node tree[4*MAXN];

node combine(node fr,node sc){
    node res={0,0,0,0};
    res.whole=max( max(fr.whole,fr.leftb)+max(sc.leftb,sc.small) , max(fr.small,fr.rightb) + sc.ans );
    res.leftb=max( fr.small + sc.ans , fr.leftb + max(sc.small,sc.leftb) );
    res.rightb=max( fr.ans + sc.small , max(fr.small,fr.rightb) + sc.rightb );
    res.small=max( fr.leftb + sc.small , fr.small + sc.rightb );
    res.ans=max( max(res.leftb,res.rightb) , max(res.whole,res.small) );
    return res;
}

void build(int v,int l,int r){
    if(l==r){
        tree[v]={a[l],0,0,0,a[l]};
    }else{
        int tt=(l+r)/2;
        build(2*v,l,tt);
        build(2*v+1,tt+1,r);
        tree[v]=combine(tree[2*v],tree[2*v+1]);
    }
}

void update(int v,int l,int r,int pos,int val){
    if(l==r){
        tree[v]={val,0,0,0,val};
    }else{
        int tt=(l+r)/2;
        if(pos<=tt)update(2*v,l,tt,pos,val);
        else update(2*v+1,tt+1,r,pos,val);
        tree[v]=combine(tree[2*v],tree[2*v+1]);
    }
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;
    for(int i=1;i<=n;i++){
        cin>>a[i];
    }
    build(1,1,n);
    cout<<tree[1].ans<<"\n";

    for(int i=1;i<=m;i++){
        cin>>pos>>c;
        update(1,1,n,pos,c);
        cout<<tree[1].ans<<"\n";
    }

    return 0;
}